function [ x ] = readMatrix( filename,showheader )
if nargin == 1
    if isstr(filename)
        showheader = 1;
    else
        showheader = filename;
        [filename,directory] = uigetfile('','Select a flat text file:');
        filename = [directory,filename];
    end
elseif nargin == 0
    showheader = 1;
    [filename,directory] = uigetfile('','Select a flat text file:');
    filename = [directory,filename];
end

fid = fopen(filename);
count = 0;

% Look for first non-header line
while count == 0
    pos = ftell(fid);
    line = fgetl(fid);
    if ~isempty(line) & line == -1
        fclose(fid);
        error('No numeric data found.')
    end
    [data,count] = sscanf(line,'%f');
    if showheader & ~count
        disp(line)
    end
end

% Point to beginning of data and read into matrix
fseek(fid,pos,'bof');
x = fscanf(fid,'%f',[count,inf])';
fclose(fid);

end

